/* inc.c */

#include <stdio.h>
#include <stdlib.h>
#include "iocrema.h"


void StampaVettore (char *nome, int *V, int s, int d);


int main (int argc, char *argv[])
{
  typedef int * pointer;
  int V[4];
  pointer p, q;
  int d, i;


  /* Inizializza V = [100 101 102 103 ] e p = &V[0] */
  for (i = 0; i <= 3; i++)
    V[i] = 100+i;
  StampaVettore("V",V,0,3);
  StampaStringa("\n");
  p = &V[0];
  StampaStringa("p = &V[0] = ");
  StampaIndirizzo(p);
  StampaStringa("\n");
  StampaVettore("p",p,0,3);
  StampaStringa("\n");

  // *++p   significa *(++p): incremento p e poi accedo all'oggetto puntato; quindi *(++V) sposta V e vale il vecchio V[1] (ora V[0])
  StampaStringa("Eseguiamo *++p; (incremento e poi accedo)\n");
  i = *++p;
  StampaStringa("*++p = ");
  StampaIntero(i);
  StampaStringa("\n");
  StampaVettore("V",V,0,3);
  StampaStringa("\n");
  StampaStringa("p = ");
  StampaIndirizzo(p);
  StampaStringa("\n");
  StampaVettore("p",p,0,3);
  StampaStringa("\n");
  StampaStringa("\n");

  /* Inizializza V = [100 101 102 103 ] e p = &V[0] */
  for (i = 0; i <= 3; i++)
    V[i] = 100+i;
  StampaVettore("V",V,0,3);
  StampaStringa("\n");
  p = &V[0];
  StampaStringa("p = &V[0] = ");
  StampaIndirizzo(p);
  StampaStringa("\n");
  StampaVettore("p",p,0,3);
  StampaStringa("\n");

  // ++*p   significa ++(*p): accedo all'oggetto puntato da p e lo incremento; quindi ++*V incrementa V[0] e vale il vecchio V[0]+1 (ora V[0])
  StampaStringa("Eseguiamo ++*p; (accedo e poi incremento)\n");
  i = ++*p;
  StampaStringa("++*p = ");
  StampaIntero(i);
  StampaStringa("\n");
  StampaVettore("V",V,0,3);
  StampaStringa("\n");
  StampaStringa("p = ");
  StampaIndirizzo(p);
  StampaStringa("\n");
  StampaVettore("p",p,0,3);
  StampaStringa("\n");
  StampaStringa("\n");

  /* Inizializza V = [100 101 102 103 ] e p = &V[0] */
  for (i = 0; i <= 3; i++)
    V[i] = 100+i;
  StampaVettore("V",V,0,3);
  StampaStringa("\n");
  p = &V[0];
  StampaStringa("p = &V[0] = ");
  StampaIndirizzo(p);
  StampaStringa("\n");
  StampaVettore("p",p,0,3);
  StampaStringa("\n");

  // *p++   significa *(p++): incremento p, ma accedo all'oggetto puntato all'inizio; quindi *V++ vale il vecchio V[0], ma sposta V (quindi vale il nuovo V[-1])
  StampaStringa("Eseguiamo *p++; (incremento, ma accedo al vecchio valore)\n");
  i = *p++;
  StampaStringa("*p++ = ");
  StampaIntero(i);
  StampaStringa("\n");
  StampaVettore("V",V,0,3);
  StampaStringa("\n");
  StampaVettore("p",p,0,3);
  StampaStringa("\n");
  StampaStringa("p = ");
  StampaIndirizzo(p);
  StampaStringa("\n");
  StampaStringa("\n");

  /* Inizializza V = [100 101 102 103 ] e p = &V[0] */
  for (i = 0; i <= 3; i++)
    V[i] = 100+i;
  StampaVettore("V",V,0,3);
  StampaStringa("\n");
  p = &V[0];
  StampaStringa("p = &V[0] = ");
  StampaIndirizzo(p);
  StampaStringa("\n");
  StampaVettore("p",p,0,3);
  StampaStringa("\n");

  // (*p)++ significa:        accedo all'oggetto puntato da p e lo incremento; quindi (*V)++ incrementa V[0] e vale il vecchio V[0]+1 (ora V[0])
  StampaStringa("Eseguiamo (*p)++; (accedo e poi incremento)\n");
  i = (*p)++;
  StampaStringa("(*p)++ = ");
  StampaIntero(i);
  StampaStringa("\n");
  StampaVettore("V",V,0,3);
  StampaStringa("\n");
  StampaStringa("p = ");
  StampaIndirizzo(p);
  StampaStringa("\n");
  StampaVettore("p",p,0,3);
  StampaStringa("\n");
  StampaStringa("\n");

  return EXIT_SUCCESS;
}


/* Stampa il vettore di interi V dall'indice s all'indice d */
void StampaVettore (char *nome, int *V, int s, int d)
{
  int i;

  StampaStringa(nome);
  StampaStringa(" = [ ");
  for (i = s; i <= d; i++)
  {
    StampaIntero(V[i]);
    StampaStringa(" ");
  }
  StampaStringa("]");
}
